import time,urllib,fcntl,codecs
from config import *
from blog_my_lib import *

class item:
  def __init__(self, new_id, timestamp):
    self.id = new_id
    self.timestamp = timestamp
    self.hidden = ['id','timestamp','hidden','sorted','disable_comments','draft']
    self.sorted = []
    self.disable_comments = False
    self.draft = False

  def loadfromxml(self, xml):
    xml = item.unicodeify_text(self,xml)
    meta = xml_quick_extract(xml, 'meta')[0]
    self.disable_comments = bool(xml_quick_extract(meta, 'disable_comments')[0])
    self.draft = bool(xml_quick_extract(meta, 'draft')[0])
    start = xml.index('</meta>')
    body = xml[start+7:]
    return xml, meta, body
    
    
  def render(self, mode='', extras=None):
    return ''

  def toweb(self):
    return {'type':self.__class__.__name__,
            'id':self.id,
            'disable_comments':self.disable_comments,
            'draft':self.draft}
    
  def tofeed(self):
    return ''

  def save(self, filename):
    pass
    
  def getTitle(self):
    return ''
    
  def unicodeify_all(self):
    for var in self.__class__.__dict__:
      #val = self.__class__.__dict__[var]
      if type(self.__class__.__dict__[var]) is type('str'):
        try:
          self.__class__.__dict__[var] = self.__class__.__dict__[var].encode('utf-8', 'replace')
        except UnicodeDecodeError:
          self.__class__.__dict__[var] = unicode(self.__class__.__dict__[var],'utf-8', 'replace')

  def unicodeify_text(self,text):
    try:
      return text.encode('utf-8', 'replace')
    except UnicodeDecodeError:
      return unicode(text,'utf-8', 'replace')

  def really_save(self, filename, meta='', data=''):
    item.unicodeify_all(self)
    contents = ''
    contents += '<meta>\n'
    if self.disable_comments:
      contents += '<disable_comments>'+str(int(self.disable_comments))+'</disable_comments>\n'
    if self.draft:
      contents += '<draft>'+str(int(self.draft))+'</draft>\n'
    contents += meta
    contents += '</meta>\n'
    contents += data
  
    FILE = codecs.open(filename, 'w', "utf-8")
    fcntl.flock(FILE, fcntl.LOCK_EX)
    FILE.write(contents)
    fcntl.flock(FILE, fcntl.LOCK_UN)
    FILE.close()

